#include "xbp.ch"
#include "appevent.ch"
#include "common.ch"
#include "gra.ch"

#define  CRLF  CHR(13)+CHR(10)

PROCEDURE AppSys()
RETURN

PROCEDURE MAIN()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg, oDa
LOCAL ostat1, oBMP
LOCAL cFile
LOCAL lExit := .F.
LOCAL aSize := {0,0}
LOCAL oPb1,oPb2
LOCAL i,iMax

   iMax := 31

   oBMP := LoadRes() :New()
   oBMP:Create()
   oBMP:Load( , 1000, "JPG" )

   aSize[1] := oBMP:xSize
   aSize[2] := oBMP:ySize

   oDlg := XbpDialog():new( AppDesktop(),,,,, .F.)
   oDlg:Icon := 1
   oDlg:title    := "Auf - Zu"
   oDlg:taskList := .T.
   oDlg:border   := XBPDLG_DLGBORDER
   oDlg:maxButton := .F.
   oDlg:minButton := .F.
   oDlg:close := { || lExit := .T. }
   oDlg:ClientSize := {aSize[1], aSize[2]+30}
   oDlg:drawingArea:clipChildren := .t.
   oDlg:create()
   CenterControl(oDlg)

   oDa := oDlg:drawingArea

   ostat1 := XbpStatic():new( oDa,, { 0, 30}, aSize)
   ostat1:type := XBPSTATIC_TYPE_BITMAP
   ostat1:Caption := oBMP
   ostat1:create()

   oPb1 := XbpPushButton():new( oDa, , {0,0}, {aSize[1]/2,30} )
   oPb1:caption := "Zu"
   oPb1:create()
   oPb1:activate:= {|| MachAufZu("ZU" ,iMax,ostat1,oPb1,oPb2, oBMP) }

   oPb2 := XbpPushButton():new( oDa, , {aSize[1]/2,0}, {aSize[1]/2,30} )
   oPb2:caption := "Auf"
   oPb2:create()
   oPb2:activate:= {|| MachAufZu("AUF",iMax,ostat1,oPb1,oPb2, oBMP) }
   oPb2:Disable()

   oDlg:show()
   SetAppFocus(oDlg)
   SetAppFocus(oPb1)

   nEvent := xbe_None
   DO WHILE !lExit = .T.
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            EXIT
         CASE nEvent == xbeP_Quit
            QUIT
      OTHERWISE
         oXbp:HandleEvent ( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oDlg:destroy()

RETURN

* -------------------------------------------------------------------------- *

FUNCTION MachAufZu(lAufZu,iMax,ostat1,oPb1,oPb2,oBMP)
LOCAL i,cFile, oPart

   IF lAufZu = "ZU"
      oPb1:Disable()
      FOR i := 1 TO iMax
         oBMP:Load(, i+999, "JPG" )
         oPart := BMP2part( oBMP, i ,iMax)
         ostat1:SetCaption(oPart)
      NEXT
      oPb2:Enable()
      SetAppFocus(oPb2)
   ELSE
      oPb2:Disable()
      FOR i := iMax TO 1 STEP -1
         oBMP:Load(, i+999, "JPG" )
         oPart := BMP2part( oBMP, i ,iMax)
         ostat1:SetCaption(oPart)
      NEXT
      oPb1:Enable()
      SetAppFocus(oPb1)
   ENDIF

RETURN NIL

* -------------------------------------------------------------------------- *

CLASS LoadRes FROM XbpBitmap

   EXPORTED:

INLINE METHOD Load( cDll, nID, cType )
LOCAL xResource, lSuccess

   DEFAULT cDll TO AppName()

   IF EMPTY( cType )
      // this is the standard :load BMP
      lSuccess := ::XbpBitmap:load( cDll, nID )
   ELSE
      // when it comes to GIF, JPG or PNG
      xResource := LoadResource( nID, cDll, cType )
      lSuccess := !EMPTY( xResource )
      ::setBuffer( xResource )
   ENDIF
RETURN ( lSuccess )

ENDCLASS

* -------------------------------------------------------------------------- *

FUNCTION BMP2part( oBMP, i ,iMax)
LOCAL oPS := XBPPRESSPACE() :new() :Create()
LOCAL oTiny := XBPBITMAP() :New() :Create()
LOCAL nSteps
LOCAL aSize := {0,0}
LOCAL aAAttr := Array( GRA_AA_COUNT )

   aSize[1] := oBMP:xSize
   aSize[2] := oBMP:ySize

   nSteps := aSize[2]/iMax

   oTiny:Make( aSize[ 1 ], aSize[ 2 ], oBMP:planes, oBMP:bits )
   oTiny:presSpace( oPS )

   aAAttr[GRA_AA_COLOR] := XBPSYSCLR_DIALOGBACKGROUND
   GraSetAttrArea(oPS, aAAttr )
   GraBox(oPS, {0,0}, {aSize[1],aSize[2]},GRA_FILL  )

   oBMP:Draw( oPS, { 0, 0, aSize[ 1 ], aSize[ 2 ]-((nSteps*i)*1) },;
                   { 0, (nSteps*i)*-1, aSize[ 1 ], aSize[ 2 ]-((nSteps*i)*1) },, GRA_BLT_BBO_IGNORE )

RETURN oTiny

*
*
*